program polygon;

{$APPTYPE CONSOLE}

uses
  Math;
  
var
  n: integer;
  x, y: array of extended;
  fi, fo: textfile;
  minY, maxY, halfArea: extended;
  iMin, iMax: integer;

  
function ToIdx(APseudoIdx: integer): integer;
begin
  Result := APseudoIdx;
  if Result < 0 then
    Inc(Result, n);
  Result := Result mod n;
end;


function Intersect(
  const AY: extended; APIdx1, APIdx2: integer; AMax: boolean): extended;
var
  i1, i2: integer;
  t: extended;
begin
  i1 := ToIdx(APIdx1);
  i2 := ToIdx(APIdx2);

  if y[i1] = y[i2] then
    if AMax then
      Result := Max(x[i1], x[i2])
    else
      Result := Min(x[i1], x[i2])
  else begin
    t := (AY - y[i1]) / (y[i2] - y[i1]);
    Result := x[i1] + t * (x[i2] - x[i1]);
  end;
end;


function Area(
  const AXL, AY: extended; const AXR: extended;
  AFIdx, ATIdx: integer): extended;
var
  i, ni: integer;
begin
  Result :=
    (AXR - AXL) * 2 * AY +
    (x[AFIdx] - AXR) * (y[AFIdx] + AY) +
    (AXL - x[ATIdx]) * (AY + y[ATIdx]);
  i := ToIdx(AFIdx);
  while (i <> ATIdx) do begin
    ni := ToIdx(i + 1); 
    Result := Result + (x[ni] - x[i]) * (y[ni] + y[i]);
    i := ni;
  end;
  Result := Abs(Result);
end;


var
  i: integer;
  l, r: integer;
  xm, ym, xl, xr, p, yp: extended;
  a: extended;
begin
  AssignFile(fi, 'input.txt');
  Reset(fi);
  AssignFile(fo, 'output.txt');
  Rewrite(fo);

  minY := 2e6;
  maxY := 0;
  iMin := -1;
  iMax := -1;
  Read(fi, n);
  SetLength(x, n);
  SetLength(y, n);
  for i := 0 to n - 1 do begin
    Read(fi, x[i], y[i]);
    if (y[i] < minY) or ((y[i] = minY) and (x[i] < x[iMin])) then begin
      minY := y[i];
      iMin := i;
    end;
    if (y[i] > maxY) or ((y[i] = maxY) and (x[i] > x[iMax])) then begin
      maxY := y[i];
      iMax := i;
    end;
  end;

  halfArea :=
    Area(x[iMax], maxY, x[iMax], ToIdx(iMax + 1), ToIdx(iMax - 1)) / 2;

  l := ToIdx(iMin + 1);
  r := ToIdx(iMin - 1);
  a := 0;
  p := 0;
  yp := minY;
  while true do begin
    if y[l] <= y[r] then begin
      xm := Intersect(y[l], r, r + 1, true);
      a := a + (p + (xm - x[l])) * (y[l] - yp);
      if (a >= halfArea) then
        Break;
      p := xm - x[l];
      yp := y[l];
      l := ToIdx(l + 1);
    end
    else begin
      xm := Intersect(y[r], l - 1, l, false);
      a := a + (p + (x[r] - xm)) * (y[r] - yp);
      if (a >= halfArea) then
        Break;
      p := x[r] - xm; 
      yp := y[r];
      r := ToIdx(r - 1);
    end;
  end;

  // now the line must be between (l - 1, l) and (r, r + 1)
  minY := Max(y[ToIdx(l - 1)], y[ToIdx(r + 1)]);  
  maxY := Min(y[l], y[r]);
  ym := (maxY + minY) / 2;
  while not IsZero(maxY - minY, 1e-4) do begin
    ym := (maxY + minY) / 2;
    xl := Intersect(ym, l - 1, l, false);
    xr := Intersect(ym, r, r + 1, true);
    a := Area(xl, ym, xr, ToIdx(r + 1), ToIdx(l - 1));
    if a < halfArea then
      minY := ym
    else
      maxY := ym;
  end;

  Write(fo, ym:0:3);

  CloseFile(fo);
  CloseFile(fi);
end.
